'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.pick');

var _lodash4 = _interopRequireDefault(_lodash3);

var _rc = require('rc');

var _rc2 = _interopRequireDefault(_rc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const defaults = {
	extends: ['angular']
};

// Resolve extend configs
function resolveExtends(config) {
	let prefix = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];
	let key = arguments.length <= 2 || arguments[2] === undefined ? 'extends' : arguments[2];

	return Object.values(config[key] || []).reduce((merged, extender) => {
		const name = [prefix, extender].filter(String).join('-');
		return (0, _lodash2.default)({}, merged, resolveExtends(require(name)));
	}, config);
}

// Get linting config

exports.default = function () {
	let name = arguments.length <= 0 || arguments[0] === undefined ? 'conventional-changelog-lint' : arguments[0];
	let settings = arguments.length <= 1 || arguments[1] === undefined ? {
		prefix: 'conventional-changelog-lint-config'
	} : arguments[1];
	let seed = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

	const config = (0, _lodash2.default)((0, _rc2.default)(name, settings.defaults), seed);
	const opts = (0, _lodash2.default)({}, defaults, (0, _lodash4.default)(config, 'extends'));
	return (0, _lodash2.default)({}, resolveExtends(opts, settings.prefix), config);
};

module.exports = exports['default'];